# -*- coding: utf-8 -*-
"""
Functions to update a graph representing citations between multiple ACS/Nature journals

"""

__authors__ = "Donna Löding, Alina Molkentin, Xinyi Tang, Judith Große, Malte Schokolowski"
__email__ = "cis-project2021@zbh.uni-hamburg.de"
__status__ = "Production"
#__copyright__ = ""
#__credits__ = ["", "", "", ""]
#__license__ = ""
#__version__ = ""
#__maintainer__ = ""

import sys  
from pathlib import Path
#sys.path.insert(1, 'C:\Users\Malte\Git\CiS-Projekt\ci-s-projekt-verarbeitung\input')
sys.path.append(".")
from input.interface import InputInterface as Input
from input_test import input_test_func
#import input
from Knoten_Vergleich import doi_listen_vergleichen
from Kanten_Vergleich import back_to_valid_edges


def get_old_input_dois(old_obj_input_list):
    old_input_dois = []
    for pub in old_obj_input_list:
        if (pub.group == "input"):
            old_input_dois.append(pub.doi_url)
    return old_input_dois

def get_new_input_dois(new_input, test_var):
    doi_input_list = []
    for new_node in new_input:
        if(test_var):
            pub = input_test_func(new_node)
        else:
            #print(pub_doi)
            inter = Input()
            try:
                pub = inter.get_publication(new_node)
            except ValueError:
                continue
            except IndexError:
                continue
        doi_input_list.append(pub.doi_url)
    return doi_input_list

def delete_ref_nodes_rec(pub):#, old_obj_list):
    for reference in pub.references:
        for ref_pub in processed_input_list:
            if (ref_pub.doi_url == reference.doi_url):
                delete_ref_nodes_rec(ref_pub)
    if (pub.group != "input"):
        processed_input_list.remove(pub)

def delete_cit_nodes_rec(pub):
    for citation in pub.citations:
        for cit_pub in processed_input_list:
            if (cit_pub.doi_url == citation.doi_url):
                delete_cit_nodes_rec(cit_pub)
    if (pub.group != "input"):
        processed_input_list.remove(pub)


def check_graph_updates(new_doi_input_list, old_obj_input_list, old_edges_list, test_var = False):
    global processed_input_list, valid_edges
    processed_input_list = old_obj_input_list
    valid_edges = []

    old_doi_input_list = get_old_input_dois(old_obj_input_list)
    new_doi_input_list = get_new_input_dois(new_doi_input_list, test_var)
    common_nodes, inserted_nodes, deleted_nodes = doi_listen_vergleichen(old_doi_input_list, new_doi_input_list)
    if (len(inserted_nodes) == 0):
        for del_node in deleted_nodes:
            for pub in processed_input_list:
                if (del_node == pub.doi_url):
                    delete_ref_nodes_rec(pub)#, processed_input_list)
                    delete_cit_nodes_rec(pub)#, processed_input_list)
                    processed_input_list.remove(pub)
        valid_edges = back_to_valid_edges(old_edges_list, processed_input_list)


    return(processed_input_list, valid_edges) 
